﻿// placeByContext.jsx
// © Gerald Singelmann, 09/2008
// Dateien platzieren per Kontextmenu. 
//
// Versucht, die ausgewählte Datei auf das markierte Objekt zu platzieren. 
// Funktioniert auch mit mehreren ausgewählten Objekten bzw. mehreren Dateien
//
// Gebrauch wie immer auf eigene Gefahr, 
// wir können nicht garantieren, dass das Script nicht mal unerwartete Ergebnisse erzeugt
// 
#targetengine "gs_clipboardplacer" 
var sMenuName = { en: "Place Clipboard", de: "Zwischenablage platzieren", ru: "Поместить из буфера" };

var myLayoutContextMenu = app.menus.item("$ID/RtMouseLayout"); 
var myTextContextMenu = app.menus.item("$ID/RtMouseText"); 

try{ 
	var myPlaceAction = app.scriptMenuActions.item(localize(sMenuName)); 
	myPlaceAction.name; 
} catch(myError) {
	var myPlaceAction = app.scriptMenuActions.add(localize(sMenuName)); 
} 
var myEventListener = myPlaceAction.eventListeners.add("onInvoke", myPlaceHandler, false); 

var myLSep = myLayoutContextMenu.menuSeparators.add();
var myLPlaceMenuItem = myLayoutContextMenu.menuItems.add(myPlaceAction); 

var errors = { };
function myPlaceHandler(myEvent) {
	try {
		errors = { en: "", de: "" };
		if (app.selection.length > 0) {
			var path = get_path_from_clipboard();
			if (path != null) {
				if (File( path ).exists) {
					for (var n = 0; n < app.selection.length; n++) {
						app.selection[n].place( File( path ) );
					}
				} else {
					errors.de += "Unter '" + path + "' liegt keine Datei.\r";
					errors.en += "There is no file under '" + path + "'\r";
                       errors.ru += "Нет файла по пути '" + path + "'\r";
				}
			}
		} else {
			errors.en += "You need to select some frame before calling this script.\r";
			errors.de += "Es muss was markiert sein, damit was hineinplatziert werden kann.\r";
             errors.ru += "Сначала надо выделить фрейм.\r";
		}
	} catch(e) {
		alert(e);
	}
	if (errors.de != "") {
		alert( localize( errors ) );
	}
}
function get_path_from_clipboard() {
	if (app.documents.length > 0) {
		var sel = app.selection;
		var tf = app.activeDocument.pages.firstItem().textFrames.add();
		app.select( tf.parentStory.insertionPoints.firstItem() );
		app.paste();
		var path = tf.parentStory.contents;
		tf.remove();
		app.select( sel );
	} else {
		errors.en += "There is no open document. How did you call this function?\r";
		errors.de += "Wie haben Sie es geschafft, dieses Script ohne offenes Dokument aufzurufen?\r";
        errors.ru += "Документ не открыт. Как вы хотите использовать этот скрипт?\r";
		path = null;
	}
	return path;
}

